<?php

class NetworkAddressModel {
  public $network_id = null;
  public $address_id = null;
  public $type = null;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  
  public static function create(Array $data) {
    $model = new NetworkAddress();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model ->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("NetworkAddress", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new NetworkAddress($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("NetworkAddress", "*");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new NetworkAddress($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("NetworkAddress", "*", "$where ORDER BY `type`");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new NetworkAddress($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("NetworkAddress", "*", "$where ORDER BY `type`");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[$data->id] = new NetworkAddress($data->id);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    $db = FronkDB::singleton();
    
    //var_dump($filter);exit;
    if(array_key_exists("network_id", $filter)) {
      $network_id = $filter['network_id'];
      if(is_numeric($network_id)) {
        $where .= " AND network_id=$network_id";
      }
    }
    
    if(array_key_exists("address_id", $filter)) {
      $address_id = $filter['address_id'];
      if(is_numeric($address_id)) {
        $where .= " AND address_id=$address_id";
      }
    }
    
    if(is_array($filter['addresstype']) && count($filter['addresstype'])) {
      $at = $filter['addresstype'];
      $in = [];
      foreach(TT_ROLES as $role) {
        if(in_array($role, $at)) {
          $role = $db->escape($role);
          $in[] = "NetworkAddress.type = '$role'";
        }
      }
      
      $or = "";
      if(count($in)) {
        $or = implode(" OR ", $in);
        $where .= " AND ( $or )";
      }
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}